/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package jdbc_gui;

import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.stage.Stage;
import DB.*;
import java.sql.DatabaseMetaData;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.beans.property.SimpleStringProperty;
import javafx.beans.value.ObservableValue;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.scene.control.Label;
import javafx.scene.control.ListView;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.TextField;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.HBox;
import javafx.util.Callback;

/**
 *
 * @author Stefan Tubic
 */
public class JDBC_GUI extends Application {
    DatabaseMetaData meta;
    String selectedTable = "radnik";
    ArrayList<String> columns = new ArrayList();
    ArrayList<TableColumn> tableColumns = new ArrayList();
    Button btn = new Button();
    //TextArea textArea = new TextArea();
    TableView<List<String>> tableView = new TableView<>();
    BorderPane borderPane, borderPane2;
    ListView<String> listView = new ListView();
    List<String> tablesList = new ArrayList();
    ObservableList<String> tablesObservableList;
    HBox hbox = new HBox();
    HBox hboxUslov = new HBox();
    TextField textFieldKolona = new TextField();
    TextField textFieldVrednost = new TextField();
    Button nextPage = new Button("Next page");
    Button pervPage = new Button("Perv page");
    Scene scene, scene2;
    
    @Override
    public void start(Stage primaryStage) {
        
        try {
            meta = DB.connection.getMetaData();
            ResultSet rs = meta.getTables(null, "dbo", null, null);
            while (rs.next()) {
                //System.out.println(rs.getString(3));
                tablesList.add(rs.getString(3));
            }
            tablesObservableList = FXCollections.observableList(tablesList);
            listView.setItems(tablesObservableList);
            listView.setOnMouseClicked(new EventHandler<MouseEvent>(){
                @Override
                public void handle(MouseEvent event) {
                    //System.out.println(listView.getSelectionModel().getSelectedItem());
                    selectedTable = listView.getSelectionModel().getSelectedItem();
                }

            });
            listView.setPrefWidth(100);
        } catch (SQLException ex) {
            Logger.getLogger(JDBC_GUI.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        btn.setText("Listaj");
        btn.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent event) {
                try{
                    columns.clear();
                    tableColumns.clear();
                    tableView.getColumns().clear();
                    tableView.getItems().clear();
                    ResultSet rs1 = meta.getColumns(null, "dbo", selectedTable, null);
                    int i = 0;
                    final int fi = i;
                    while (rs1.next()) {
                        final int colIndex = i;
                        //System.out.println(rs1.getString("COLUMN_NAME"));
                        String col = rs1.getString("COLUMN_NAME");
                        TableColumn tableCol = new TableColumn(col);
                        tableCol.setCellValueFactory(new Callback<TableColumn.CellDataFeatures<List<String>, String>, ObservableValue<String>>() {

                            @Override
                            public ObservableValue<String> call(TableColumn.CellDataFeatures<List<String>, String> p) {
                                if (p.getValue() != null) {
                                    List<String> v = p.getValue();
                                    String colVal = v.get(colIndex);
                                    return new SimpleStringProperty(colVal);
                                } else {
                                    return new SimpleStringProperty("<no name>");
                                }
                            }
                        });
                        columns.add(col);
                        tableColumns.add(tableCol);
                        tableView.getColumns().add(tableCol);
                        i++;
                    }
                    
                    Statement stm = DB.connection.createStatement();
                    String query = "";
                    if(textFieldKolona.getText().isEmpty() || textFieldVrednost.getText().isEmpty()){
                        query = "select * from " + selectedTable;
                    }
                    else{
                        query = "select * from " + selectedTable + 
                        " where " + textFieldKolona.getText() + " = " + "'" + textFieldVrednost.getText() + "'";
                    }
                    
                    ResultSet rs = null;
                    try{
                        rs = stm.executeQuery(query);
                    }
                    catch(SQLException ex){
                        query = "select * from " + selectedTable;
                        rs = stm.executeQuery(query);
                    }
                    
                    while(rs.next()){
                        ArrayList<String> row = new ArrayList<>();
                        for(int j = 1; j <= rs.getMetaData().getColumnCount(); j++){
                            //System.out.print(rs.getString(j));
                            row.add(rs.getString(j));
                        }
                        tableView.getItems().add(FXCollections.observableList(row));
                    }
                    rs.close();
                    stm.close();
                } catch (SQLException ex) {
                    Logger.getLogger(JDBC_GUI.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        });
        
        hbox.getChildren().add(nextPage);
        hbox.getChildren().add(btn);
        hboxUslov.getChildren().add(new Label("Kolona: "));
        hboxUslov.getChildren().add(textFieldKolona);
        hboxUslov.getChildren().add(new Label("Vrednost: "));
        hboxUslov.getChildren().add(textFieldVrednost);
        hbox.getChildren().add(hboxUslov);
        borderPane = new BorderPane();
        borderPane.setCenter(tableView);
        borderPane.setBottom(hbox);
        borderPane.setLeft(listView);
        //root.getChildren().add(btn);
        
        scene = new Scene(borderPane, 700, 250);
        
        
        borderPane2 = new BorderPane();
        borderPane2.setCenter(pervPage);
        scene2 = new Scene(borderPane2, 700, 250);
        
        nextPage.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent event) {
                primaryStage.setScene(scene2);
            }
        });
        
        pervPage.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent event) {
                primaryStage.setScene(scene);
            }
        });
        //Scene scene2 = new Scene(null, 500, 250);
        
        primaryStage.setTitle("JDBC");
        primaryStage.setScene(scene);
        primaryStage.show();
    }

    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        launch(args);
    }
    
}
